autowatch = 1;
outlets = 4;

var inputChunk, targetChunk, inputChunkName, targetChunkName, dataBuffer, samps, features;
var chunksSet = false;
var dataBufferSet = false;
var featuresSet = false;
var _verbose = false;
var _chunkSize = 10;

function verbose(v) {
	if (v != 0) {
		_verbose = true;
	} else {
		_verbose = false;
	}
}

function chunkbuffers() {
    var args = arrayfromargs(arguments);
    inputChunk = new Buffer(args[0]);
    inputChunkName = args[0];
    targetChunk = new Buffer(args[1]);
    targetChunkName = args[1];
    chunksSet = true;
	if (_verbose) {
		outlet(3, "Input chunk buffer set to:", args[0], "\nOutput chunk buffer set to:", args[1], "\n");
	}
}

function chunksize(chsize) {
    _chunkSize = chsize;
	if (_verbose) {
    	outlet(3, "Chunk size changed to", chsize, "\n");
	}
}

function databuffer(bufname) {
    dataBuffer = new Buffer(bufname);
    samps = dataBuffer.framecount();
    dataBufferSet = true;
	if (_verbose) {
    	outlet(3, "Data buffer set to:", bufname, "\n");
	}
}

function numfeatures(feats) {
    features = feats;
    featuresSet = true;
	if (_verbose) {
    	outlet(3, "Number of features changed to", features, "\n");
	}
}

function chunk() {
    if (!chunksSet || !dataBufferSet || !featuresSet) {
        outlet(3, "Set the input and target buffers, the data buffer and the number of features before chunking.\n");
        return;
    }

    var counter = 0;
    var index = 0;
    var chunkIn, chunkTarget;

    inputChunk.send("samps", _chunkSize*features);
    targetChunk.send("samps", _chunkSize*features);

    outlet(0, "clear");
    outlet(1, "clear");

    while (index < samps) {
        chunkIn = dataBuffer.peek(1, index, _chunkSize*features);
        chunkTarget = dataBuffer.peek(1, index+features, _chunkSize*features);

        inputChunk.send("clear");
        targetChunk.send("clear");

        inputChunk.poke(1, 0, chunkIn);
        targetChunk.poke(1, 0, chunkTarget);

        outlet(0, "addpoint", counter.toString(), inputChunkName);
        outlet(1, "addpoint", counter.toString(), targetChunkName);

        counter += 1;
        index += features;
    }

    outlet(2, "bang");
}